import sys, os
import gtk
import pango

class lathe:

  def __init__(self, halcomp, builder, useropts):
    self.halcomp = halcomp
    self.builder = builder
    '''
    # setup the profile tab
    self.pathstore = gtk.ListStore(str)
    self.pathview = self.builder.get_object('pathview')
    self.pathview.set_model(self.pathstore)

    self.path_column = gtk.TreeViewColumn("Profile Path")
    self.path_column.set_expand(True)
    self.path_column.set_alignment(0.5)
    self.pathview.append_column(self.path_column)


    self.path_cell = gtk.CellRendererText()
    self.path_cell.set_property("editable", True)
    self.path_cell.connect("edited", self.text_edited, self.pathstore, 0)
    self.path_cell.set_property("alignment",pango.ALIGN_CENTER)
    self.path_column.pack_start(self.path_cell, False)
    self.path_column.add_attribute(self.path_cell, "text", 0)

    self.path_entry = self.builder.get_object('path_entry')
    self.path_entry.connect('activate', self.addto_list)

    self.locations = []
    self.path_list = []
    '''

  def addto_list(self, var):
    self.gcode = self.gcode_format(self.path_entry.get_text().upper())
    self.iter = self.pathstore.append([self.gcode])
    self.path_entry.set_text('')
    self.rebuild_path_list()
    self.path_entry.grab_focus()

  def gcode_format(self, var):
    self.gcode = ''
    for i in var:
      if i.isalpha() and var.index(i) > 0:
        self.gcode += ' ' + i
      else:
        self.gcode += i
    return self.gcode

  def text_edited(self, widget, path, text, model, column):
      model[path][column] = text
      self.rebuild_path_list()

  def rebuild_path_list(self):
    self.path_list = []
    for i in range(len(self.pathstore)):
      self.iter = self.pathstore.get_iter(i)
      self.path_list.append(self.pathstore[self.iter][0])

  def on_send_path_btn_clicked(self, obj, data=None):
    pass

  def on_create_button_clicked(self, ojb, data=None):
    self.gcode = []
    self.gcode.append(';testing')
    self.gcode.append('M2')
    self.f = open('temp.ngc', 'w')
    for item in self.gcode:
      self.f.write('%s\n' % item)
    self.f.close()
    

  def on_send_button_clicked(self, obj, data=None):
    os.system('axis-remote temp.ngc')

  def on_open_file_clicked(self, obj, data=None):
    print 'Open File'
    self.c.mode(linuxcnc.MODE_AUTO)
    self.c.wait_complete()
    self.c.program_open(self.file_dir+ 'lathe02.ngc')

def get_handlers(halcomp, builder, useropts):
  return [lathe(halcomp, builder, useropts)]
